#include "navigation.h"

void		zoom_in(widget, event)
GtkWidget	*widget ;
GdkEvent	*event ;
{
  Wavwin		*ww ;
  unsigned long int	width ;
  unsigned int		iwidth ;
  unsigned long int	x ;
  unsigned long int	y ;
  GtkAdjustment		*adj ;
  
  ww = WAVWIN(widget) ;
  switch (gtk_notebook_current_page(GTK_NOTEBOOK (ww->notebook))) 
    {
    case STANDARD :
      width = ((y = WAVEDITOR (ww->wve[STANDARD])->part_watched.y) - 
	(x = WAVEDITOR (ww->wve[STANDARD])->part_watched.x)) / 2 ;
      iwidth = WAVEDITOR (ww->wve[STANDARD])->DrawingArea[LEFT]->allocation.width ;
      if (width > iwidth) {
	WAVEDITOR (ww->wve[STANDARD])->part_watched.x = x + width / 2 ;
	WAVEDITOR (ww->wve[STANDARD])->part_watched.y = y - width / 2 ;
      } else {
	WAVEDITOR (ww->wve[STANDARD])->part_watched.x = x + width / 2 - iwidth / 2 ;
	WAVEDITOR (ww->wve[STANDARD])->part_watched.y = y - width / 2 + iwidth / 2 ;
      }
      adj = gtk_range_get_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])
						->hscrollbar)) ;
      adj->page_size = WAVEDITOR (ww->wve[STANDARD])->part_watched.y - 
	WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
      adj->step_increment = adj->page_size / STEP_INC ;
      adj->value = WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
      gtk_range_set_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])->hscrollbar),
			       adj) ;
      gtk_signal_emit_by_name(GTK_OBJECT (adj), "changed");
      //gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
//			      "channel_left_configure") ;
      gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
      			      "channel_right_configure") ;
    break ;
    case VOLUME :
      break ;
    case PANNING :
      break ;
    }
}


void		zoom_out(widget, event)
GtkWidget	*widget ;
GdkEvent	*event ;
{
  Wavwin		*ww ;
  unsigned long int	width ;
  unsigned long int	x ;
  unsigned long int	y ;
  GtkAdjustment		*adj ;
  
  ww = WAVWIN(widget) ;
  switch (gtk_notebook_current_page(GTK_NOTEBOOK (ww->notebook))) 
    {
    case STANDARD :
      adj = gtk_range_get_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])
						->hscrollbar)) ;      
      width = ((y = WAVEDITOR (ww->wve[STANDARD])->part_watched.y) - 
	(x = WAVEDITOR (ww->wve[STANDARD])->part_watched.x)) / 2 ;
      WAVEDITOR (ww->wve[STANDARD])->part_watched.x = 
	((signed long int)(x - width) < 0 ? 0 : x - width) ;
      WAVEDITOR (ww->wve[STANDARD])->part_watched.y = 
	(y + width > adj->upper  ? 
	 adj->upper : y + width) ;
      adj->page_size = WAVEDITOR (ww->wve[STANDARD])->part_watched.y - 
	WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
      adj->step_increment = adj->page_size / STEP_INC ;
      adj->value = WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
      gtk_range_set_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])->hscrollbar),
			       adj) ;
      gtk_signal_emit_by_name(GTK_OBJECT (adj), "changed");
//      gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
//			      "channel_left_configure") ;
      gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
			      "channel_right_configure") ;
    break ;
    case VOLUME :
      break ;
    case PANNING :
      break ;
    }
}


void		zoom_in_sel(widget, event)
GtkWidget	*widget ;
GdkEvent	*event ;
{
  Wavwin		*ww ;
  GtkAdjustment		*adj ;
  
  ww = WAVWIN(widget) ;

  switch (gtk_notebook_current_page(GTK_NOTEBOOK (ww->notebook))) 
    {
    case STANDARD :
      if (WAVEDITOR (ww->wve[STANDARD])->there_is_a_selection)
      {
	if (WAVEDITOR (ww->wve[STANDARD])->selection.y - 
	  WAVEDITOR (ww->wve[STANDARD])->selection.x >= 
	  WAVEDITOR (ww->wve[STANDARD])->DrawingArea[LEFT]->allocation.width)
	{
	  WAVEDITOR (ww->wve[STANDARD])->part_watched.x =  
	    WAVEDITOR (ww->wve[STANDARD])->selection.x ;
	  WAVEDITOR (ww->wve[STANDARD])->part_watched.y =  
	    WAVEDITOR (ww->wve[STANDARD])->selection.y ;
	} else
	{
	  WAVEDITOR (ww->wve[STANDARD])->part_watched.x =  
	    WAVEDITOR (ww->wve[STANDARD])->selection.x ;
	  WAVEDITOR (ww->wve[STANDARD])->part_watched.y =  
	    WAVEDITOR (ww->wve[STANDARD])->selection.x +
	    WAVEDITOR (ww->wve[STANDARD])->DrawingArea[LEFT]->allocation.width ;
	}
	
	adj = gtk_range_get_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])
						  ->hscrollbar)) ;
	adj->page_size = WAVEDITOR (ww->wve[STANDARD])->part_watched.y - 
	  WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
	adj->step_increment = adj->page_size / STEP_INC ;
	adj->value = WAVEDITOR (ww->wve[STANDARD])->part_watched.x ;
	gtk_range_set_adjustment(GTK_RANGE (WAVEDITOR (ww->wve[STANDARD])->hscrollbar),
				 adj) ;
	gtk_signal_emit_by_name(GTK_OBJECT (adj), "changed");
	gtk_signal_emit_by_name(GTK_OBJECT (ww->wve[STANDARD]), 
				"channel_right_configure") ;
      }
    break ;
    case VOLUME :
      break ;
    case PANNING :
      break ;
    }
}


void		update_scroll(wve, tempgmurf)
Waveditor	*wve ;
t_tempgmurf	*tempgmurf ;
{
  GtkAdjustment		*adj ;
	
  adj = gtk_range_get_adjustment(GTK_RANGE (wve->hscrollbar)) ;

  if (adj->upper > tempgmurf->temp_size / 4)
    {
      wve->part_watched.x = 0 ;
      wve->part_watched.y = tempgmurf->temp_size / 4 ;
      adj->page_size = wve->part_watched.y - 
	wve->part_watched.x ;
      adj->step_increment = adj->page_size / STEP_INC ;
      adj->value = wve->part_watched.x ;
      wve_erase_selection(wve) ;
    }
  adj->upper = tempgmurf->temp_size / 4 ;
  gtk_range_set_adjustment(GTK_RANGE (wve->hscrollbar), adj) ;
  gtk_signal_emit_by_name(GTK_OBJECT (adj), "changed");
}







