/*
** wavwin_init.h for Gmurf in Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Wed Feb 17 12:35:49 1999 Rmi Coupet
** Last update Fri Mar 12 20:26:32 1999 Rmi Coupet
*/

#ifndef __WAVWIN_INIT__

#define __WAVWIN_INIT__

#include "gui.h"
#include "waveditor.h"
#include "wavwindow.h"
#include "Menu.h"
#include "item.h"
#include "TempGmurf.h"
#include "navigation.h"
#include "PlayTempFile.h"
#include "draw_wav.h"
#include "draw_wav_funcs_basic.h"
#include "Mixer.h"
#include "mixer_launch.h"
#include "Load_Sound.h"
#include "mix_sample.h"
#include "InOut.h"
#include "Constants.h"
#include "MixerTypes.h"

void		new_wav_editor			(t_tempgmurf	*tempgmurf);
void		init_wav_play_buttons		(Wavwin		*ww,
						 GtkWidget	*win_for_pix,
						 ITEM		*play_button,
						 int		nb_buttons) ;
void		init_navigation_buttons		(Wavwin		*ww,
						 GtkWidget	*win_for_pix,
						 ITEM		*navigate,
						 int		nb_buttons) ;
void		init_representation_buttons	(Wavwin		*ww,
						 GtkWidget	*win_for_pix,
						 ITEM		*represent,
						 int		nb_buttons) ;
void		close_ww			(GtkWidget	*widget) ;
void 		connect_with_wav_editor		(t_tempgmurf	*tempgmurf,
						 Mixer_Sample	*ms) ;

#endif















